
/**
 * Diese Klasse beschreibt eine Person. Fr eine einzelne Person knnen mehrere biometrische 
 * Beschreibungen hinterlegt sein. Dies ermglicht, in der Klasse BIOMETRIE nicht nur alle
 * Gesichter zu bearbeiten - sondern auch konfortabel alle Gesichter eine Person. So diese
 * Funktionalitt nicht fr Erweiterungen der Klasse BIOMETRIE gewnscht ist, kann hier sehr
 * viel entfallen und das Projekt dadurch etwas einfacher werden.
 * 
 * @version 1.0
 */

public class PERSON
{
    private String name;         // Name der Person
    private boolean bekannt;     // Angabe, ob die Person bekannt oder zu identifizieren ist
    private GESICHT[] gesichter; // Fr die Person gespeicherte Gesichter
    private int anzahl;          // Anzahl der fr die Person gespeicherten Gesichter

    /**
     * Erstellt ein Objekt der Klasse PERSON. Zu jeder Person knnen eine hier festgelegte
     * Anzahl von Gesichtern gespeichert werden. Sollen zur Laufzeigt mehr Gesichter 
     * gespeichert werden liefert die Methode addGesicht eine Fehlermeldung.
     * 
     * @param aName Name der Person.
     */
    public PERSON(String aName, boolean aBekannt)
    {
        name = aName;
        bekannt = aBekannt;
        gesichter = new GESICHT[10];
        anzahl = 0;      
    }
   
    /**
     * Registriert eine weitere biometrische Beschreibung fr ein Gesicht der Person. Falls
     * die maximale Anzahl von Gesichter erreicht wurde, gibt die Funktion false zurck.
     * 
     * @param aGesicht Gesicht der Person
     * @return Wahr, falls Gesicht registriert werden konnte
     */
    public boolean addGesicht(GESICHT aGesicht)
    {
        if (anzahl < gesichter.length) 
        {
           gesichter[anzahl] = aGesicht;
           anzahl++;
           return true;
        }      
        System.out.println("Gesicht konnte nicht registriert werden.");
        return false;
    }

    /**
     * Liefert den Namen der Person
     * @return Name 
     */
    public String getPersonName()
    {
        return name;
    }

    /**
     * Liefert die Anzahl der fr die Person registrierten Gesichter
     * @return Anzahl der Gesichter
     */
    public int getGesichterzahl()
    {
        return anzahl;
    }    

    /**
     * Liefert eins der fr die Person registrierten Gesichter. Der Rckgabewerte ist null, falls
     * fr diesen Index kein Gesicht existiert.
     * 
     * @param aIndex Index des gewnschten Gesicht (0 bis getGesichterzahl()-1)
     * @return Gesichtsbiometrie (Objekt der Klasse GESICHT)
     */
    public GESICHT getGesicht(int aIndex)
    {
        if ((aIndex >= 0) && (aIndex < anzahl))
        { 
            return gesichter[aIndex];
        }    
        System.out.println("Gesicht mit Index "+aIndex+" nicht verfgbar");
        return null;
    }    
    
    public boolean getBekannt()
    {
        return bekannt;
    }    
}
